<?php
/*****************************************************************************/
/* InstantMessage.php                                                        */
/*****************************************************************************/
/* YaBB SE: Yet another Bulletin Board Splinter Edition                      */
/* Open-Source Project inspired by Zef Hemel (zef@zefhemel.com)              */
/* Software Version:           YaBB SE 1.5.1                                 */
/* Software by:                The YaBB SE Development Team                  */
/* ========================================================================= */
/* Software Distributed by:    http://www.yabbse.org                         */
/* Copyright 2001-2003 by:     http://www.lewismedia.com (Lewis Media)       */
/* Support, News, Updates at:  http://www.yabbse.org/community               */
/* Inspired and Ported From:   http://www.yabbforum.com                      */
/*****************************************************************************/
/* This program is free software; you may redistribute it and/or modify it   */
/* under the terms of the provided license as published by Lewis Media.      */
/*                                                                           */
/* This program is distributed in the hope that it will be useful, but       */
/* WITHOUT ANY WARRANTY; without even the implied warranty of                */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the provided    */
/* license for more information.                                             */
/*                                                                           */
/* See license.txt for details of the YaBB SE license. The latest version    */
/* of this license can be found at the distributor's site seen above.        */
/*****************************************************************************/

$instantmessagephpver = 'YaBB SE 1.5.3';

function IMIndex()
{
	global $username, $txt, $img, $yytitle, $imagesdir, $cgi, $action, $mbname, $censored, $scripturl;
	global $menusep, $color, $ID_MEMBER, $yyUDLoaded, $userprofile, $membergroups, $memberstar, $memberinfo, $icqad;
	global $yimon, $currentboard, $profilebutton, $enable_ubbc, $settings, $allow_hide_email, $db_prefix;
	global $modSettings, $sender, $realNames, $sc;
	if ( $username == 'Guest' )
		fatal_error($txt[147]);

	$imbox = $txt[316];
	$txt[412] = str_replace('IMBOX', $imbox, $txt[412]);
	$img['im_delete'] = str_replace('IMBOX', $imbox, $img['im_delete']);

	$sender = 'im';

	$yytitle = $txt[143];

	// Build the link tree
	$displayLinkTree = ($modSettings['enableInlineLinks'] ? "<font size=\"1\" class=\"nav\"><b><a href=\"$scripturl\" class=\"nav\">$mbname</a> </b>&nbsp;|&nbsp;<b> " : "<font size=\"2\" class=\"nav\"><b><img src=\"$imagesdir/open.gif\" border=\"0\" alt=\"\" />&nbsp;&nbsp;<a href=\"$scripturl\" class=\"nav\">$mbname</a><br />") ;
	$displayLinkTree .= ($modSettings['enableInlineLinks'] ? "<a href=\"$cgi;action=im\" class=\"nav\">$txt[144]</a> </b>&nbsp;|&nbsp;<b> " : "<img src=\"$imagesdir/tline.gif\" border=\"0\" alt=\"\" /><img src=\"$imagesdir/open.gif\" border=\"0\" alt=\"\" />&nbsp;&nbsp;<a href=\"$cgi;action=im\" class=\"nav\">$txt[144]</a><br />");
	$displayLinkTree .= ($modSettings['enableInlineLinks'] ? "$txt[316]</b></font>" : "<img src=\"$imagesdir/tline2.gif\" border=\"0\" alt=\"\" /><img src=\"$imagesdir/open.gif\" border=\"0\" alt=\"\" />&nbsp;&nbsp;<a href=\"$cgi;action=im\" class=\"nav\">$txt[316]</a></b></font>");

	template_header();

	echo '
		<script language="JavaScript1.2" type="text/javascript"><!--
			function DoConfirm(message, url) {
				if (confirm(message)) location.href = url;
			}
			function invertAll(field, headerfield)
			{
				for (i = 0; i < field.length; i++) {
					if (headerfield.checked == false )
						field[i].checked = true;
					else
						field[i].checked = false;
				}
				headerfield.checked = !(headerfield.checked);
			}
		//--></script>
		<table border="0" width="100%" cellspacing="0" cellpadding="0">
			<tr>
				<td valign="bottom">' . $displayLinkTree . '</td>
			</tr>
		</table>
		<form action="' . $cgi . ';action=imremovemore;caller=1" method="post" onsubmit="if (!confirm(\'' . $txt['yse249'] . '\')) return false;" style="margin-top: 0px;">
			<table cellpadding="0" cellspacing="0" border="0" width="100%" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" align="center"><tr><td>
				<table border="0" width="100%" cellspacing="1" bgcolor="' . $color['bordercolor'] . '" class="bordercolor">
					<tr>
						<td align="right" valign="bottom" class="catbg" bgcolor="' . $color['catbg'] . '" colspan="5">
							<font size="-1">';

	// Load membergroups
	$request = mysql_query("SELECT membergroup FROM {$db_prefix}membergroups WHERE 1 ORDER BY ID_GROUP") or database_error(__FILE__, __LINE__);
	$membergroups = array();
	while ($row = mysql_fetch_row($request))
		$membergroups[] = $row[0];

	// Load Messages
	$request = mysql_query("UPDATE {$db_prefix}instant_messages SET readBy=1 WHERE ID_MEMBER_TO=$ID_MEMBER AND readBy='0'") or database_error(__FILE__, __LINE__);
	$request = mysql_query("SELECT ID_IM, fromName, subject, body, msgtime FROM {$db_prefix}instant_messages WHERE ID_MEMBER_TO=$ID_MEMBER AND deletedBy != 1 ORDER BY ID_IM") or database_error(__FILE__, __LINE__);
	if (mysql_num_rows($request) > 0)
		echo "<a href=\"$cgi;action=imremoveall;caller=1\">$img[im_delete]</a>$menusep";

	echo '
								<a href="' . $cgi . ';action=imoutbox">' . $img['im_outbox'] . '</a>' . $menusep . '<a href="' . $cgi . ';action=imsend">' . $img['im_new'] . '</a>' . $menusep . '<a href="' . $cgi . ';action=im">' . $img['im_reload'] . '</a>' . $menusep . '<a href="' . $cgi . ';action=imprefs">' . $img['im_config'] . '</a>
							</font>
						</td>
					</tr><tr>
						<td class="titlebg" bgcolor="' . $color['titlebg'] . '" width="300"><font size="2" class="text1" color="' . $color['titletext'] . '">&nbsp;<b>' . $txt[317] . '</b></font></td>
						<td class="titlebg" bgcolor="' . $color['titlebg'] . '"><font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $txt[318] . '</b></font></td>
						<td class="titlebg" bgcolor="' . $color['titlebg'] . '"><font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $txt[319] . '</b></font></td>
						<td class="titlebg" bgcolor="' . $color['titlebg'] . '"><font size="2" class="text1" color="' . $color['titletext'] . '">' . $txt['yse138'] . '</font></td>
						<td class="titlebg" bgcolor="' . $color['titlebg'] . '" align="center"><input class="titelbg" style="background-color:' . $color['titlebg'] . '" type="checkbox" onclick="invertAll(this.form, this)"/></td>
					</tr>';
	if ( mysql_num_rows($request)  == 0 )
		echo '
					<tr>
						<td class="windowbg" colspan="5" bgcolor="' . $color['windowbg'] . '"><font size="2">' . $txt[151] . '</font></td>
					</tr>';

	$bgcolors = array($color['windowbg'], $color['windowbg2']);
	$bgstyles = array('windowbg', 'windowbg2');
	$bgcolornum = sizeof($bgcolors);
	$bgstylenum = sizeof($bgstyles);

	$counter = 0;
	$ims = array();
	while ($row = mysql_fetch_array($request))
	{
		$ims[] = $row['ID_IM'];
		$counter++;
		$musername = $row['fromName'];
		$msub = $row['subject'];
		$mdate = $row['msgtime'];
		$immessage = $row['body'];
		$messageid = $row['ID_IM'];
		$windowbg = $bgcolors[($counter % $bgcolornum)];
		$windowcss = $bgstyles[($counter % $bgstylenum)];
		if ( $msub == '' ) { $msub = $txt[24]; }
		CensorTxt($msub);
		$mydate = timeformat($mdate);
		echo '
					<tr>
						<td class="' . $windowcss . '" bgcolor="' . $windowbg . '" width="300"><font size="2">' . $mydate . '</font></td>
						<td class="' . $windowcss . '" bgcolor="' . $windowbg . '"><font size="2">' . $musername . '</font></td>
						<td class="' . $windowcss . '" bgcolor="' . $windowbg . '"><font size="2"><a href="#' . $messageid . '">' . $msub . '</a></font></td>
						<td class="' . $windowcss . '" bgcolor="' . $windowbg . '">
							<font size="2">
								<a href="javascript:DoConfirm(\'' . addslashes($txt[154]) . '?\',\'' . $cgi . ';action=imremove;caller=1;id=' . $messageid . ';sesc=' . $sc . '\');">' . $img['im_remove'] . '</a>
							</font>
						</td>
						<td class="' . $windowcss . '" bgcolor="' . $windowbg . '" align="center">
							<input class="' . $windowcss . '" type="checkbox" name="delete_' . $messageid . '" />
						</td>
					</tr>';
	}
	$windowbg = $bgcolors[(++ $counter % $bgcolornum)];
	echo '
					<tr>
						<td bgcolor="' . $windowbg . '" class="windowbg2" style="padding: 2px;" align="right" colspan="5">
							<input type="submit" value="' . $txt['yse138'] . '" />
						</td>
					</tr>
				</table>
			</td></tr></table>
			<input type="hidden" name="sc" value="' . $sc. '" />
		</form><br />';

	if (mysql_num_rows($request) > 0)
	{
		echo '
			<table border="0" width="100%" cellspacing="1" cellpadding="4" bgcolor="' . $color['bordercolor'] . '" class="bordercolor">
				<tr>
					<td class="titlebg" bgcolor="' . $color['titlebg'] . '">
						<font size="2" class="text1" color="' . $color['titletext'] . '">
							&nbsp;<b>' . $txt[29] . '</b>
						</font>
					</td>
					<td class="titlebg" bgcolor="' . $color['titlebg'] . '">
						<font size="2" class="text1" color="' . $color['titletext'] . '">
							<b>' . $txt[118] . '</b>
						</font>
					</td>
				</tr>';

		$request = mysql_query("
			SELECT im.fromName, im.subject, im.msgtime, im.body, im.ID_IM, IFNULL(mem.ID_MEMBER, 0) AS ID_MEMBER_FROM, IFNULL(mem.realName,im.fromName) AS fromDisplayName, IFNULL(lo.logTime, 0) AS isOnline
			FROM {$db_prefix}instant_messages AS im
				LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER=im.ID_MEMBER_FROM)
				LEFT JOIN {$db_prefix}log_online AS lo ON (lo.identity=mem.ID_MEMBER)
			WHERE im.ID_IM IN (" . implode(',', $ims) . ")
			ORDER BY im.ID_IM") or database_error(__FILE__, __LINE__);

		$counter = 0;
		while ($row = mysql_fetch_array($request))
		{
			$counter++;
			$windowbg = $bgcolors[($counter % $bgcolornum)];
			$windowcss = $bgstyles[($counter % $bgstylenum)];
			$musername = $row['fromName'];
			$msub = $row['subject'];
			$mdate = $row['msgtime'];
			$immessage = $row['body'];
			$messageid = $row['ID_IM'];
			if ($msub == '') 
				$msub = $txt[24];
			$mydate = timeformat($mdate);

			// If user is not in memory, s/he must be loaded.
			if ($row['ID_MEMBER_FROM'] > 0 && !isset($yyUDLoaded[$musername]))
			{
				$realNames[$musername] = $row['fromDisplayName'];
				LoadUserDisplay($musername);
			}

			$online ='';
			$title = '';
			if ($yyUDLoaded[$musername])
			{
				$deleted = 0;
				$star = $memberstar[$musername];
				$memberinf = $memberinfo[$musername];
				$icq = $icqad[$musername];
				$yim = $yimon[$musername];
				$memail = $userprofile[$musername]['emailAddress'];
				$euser = urlencode($musername);
				$usernamelink = "<a href=\"$scripturl?board=$currentboard;action=viewprofile;user=$euser\"><font size=\"2\"><b>{$userprofile[$musername]['realName']}</b></font></a>";
				$profileButtons = array();
				if (strlen($userprofile[$musername]['websiteUrl_IM']))
					$profileButtons[] = $userprofile[$musername]['websiteUrl_IM'];
				if ($userprofile[$musername]['hideEmail'] != '1' || $settings[7] == "Administrator" || $allow_hide_email != '1')
					$profileButtons[] = "<a href=\"mailto:$memail\">$img[email]</a>";
				if ($profilebutton != '' && $musername != 'Guest')
					$profileButtons[] = "<a href=\"$scripturl?action=viewprofile;user=$euser\">$img[viewprofile]</a>";
				$profbutton = (($profilebutton != '' && $musername != 'Guest') ? "$menusep<a href=\"$scripturl?action=viewprofile;user=$euser\">$img[viewprofile]</a>" : '');
				$postinfo = "$txt[26]: {$userprofile[$musername]['posts']}<br />";
				$memail = $userprofile[$musername]['emailAddress'];
				if ($modSettings['titlesEnable'] != '0' && $userprofile[$musername]['usertitle'] != '')
					$title = "{$userprofile[$musername]['usertitle']}<br />";
				if ($modSettings['onlineEnable'] != '0') 
				{
					if ($row['isOnline'] > 0)
						$online = '<a href="' . $cgi . ';action=imsend;to=' . $euser . '">' . $txt['online2'] . '<br /><br />' . "\n";
					else 
						$online = '<a href="' . $cgi . ';action=imsend;to=' . $euser . '">' . $txt['online3'] . '<br /><br />' . "\n";
				}
				else
					$online = '';
			}
			else // user has been deleted
			{
				$deleted = 1;
				$star = '';
				$memberinf = '';
				$icq = '';
				$yim = '';
				$usernamelink = $musername;
				$postinfo = '';
				$memail = '';
				$profileButtons = array();
				if ($userprofile[$musername]['hideEmail'] != '1' || $settings[7] == "Administrator" || $allow_hide_email != '1')
					$profileButtons[] = "<a href=\"mailto:$memail\">$img[email]</a>";
			}

			CensorTxt($immessage);
			CensorTxt($msub);

			$message = $immessage; // put the message back in the proper variable for doing ubbc
			if ($enable_ubbc)
				$message = DoUBBC($message);
			$message = str_replace('<br>', '<br />', $message);

			echo '
			<tr>
				<td class="' . $windowcss . '" bgcolor="' . $windowbg . '" width="160" valign="top" height="100%" rowspan="2">
					' . $usernamelink . '<br />
					<font size="1">
						' . $title . ' ' . $memberinf . '<br />
						' . $star . '<br /><br />
						' . $online . ' ' . $postinfo . '
						' . $userprofile[$musername]['gender'] . '
						' . $userprofile[$musername]['avatar'] . ' ' . $userprofile[$musername]['personalText'] . ' ' . $userprofile[$musername]['ICQ'] . ' ' . $icq . ' &nbsp; ' . $yim . ' &nbsp; ' . $userprofile[$musername]['AIM'] . '
					</font>
				</td>
				<td class="' . $windowcss . '" bgcolor="' . $windowbg . '" valign="top" height="100%">
					<table border="0" cellspacing="0" cellpadding="3" width="100%" align="center" bgcolor="' . $color['bordercolor'] . '" class="bordercolor">
						<tr class="' . $windowcss . '" bgcolor="' . $windowbg . '">
							<td class="' . $windowcss . '" bgcolor="' . $windowbg . '"><a name="' . $messageid . '" /><font size="1">&nbsp;<b>' . $msub . '</b></font></td>
							<td class="' . $windowcss . '" bgcolor="' . $windowbg . '" align="right"><font size="1"><b>' . $txt[30] . ':</b> ' . $mydate . '</font></td>
						</tr><tr>
							<td class="' . $windowcss . '" bgcolor="' . $windowbg . '" colspan="2">
								<hr width="100%" size="1" style="color: ' . $color['windowbg3'] . '" />
								<font size="2">' . $message . '</font>
							</td>
						</tr>
					</table>
				</td>
			</tr><tr>
				<td class="' . $windowcss . '" bgcolor="' . $windowbg . '" colspan="2" valign="bottom">
					' . $userprofile[$musername]['signature'] . '
					<hr width="100%" size="1" style="color: ' . $color['windowbg3'] . '" />
					<table width="100%"><tr><td class="' . $windowcss . '" bgcolor="' . $windowbg . '" height="10" align="left" valign="bottom">
						<font size="2">' . implode($menusep, $profileButtons) . '</font>
					</td>
					<td class="' . $windowcss . '" bgcolor="' . $windowbg . '" height="10" align="right" valign="bottom">
						<font size="2">';
			if (!$deleted) 
				echo "<a href=\"$cgi;action=imsend;caller=1;imsg=$messageid;quote=1;to=$musername;ry=1\">$img[replyquote]</a>$menusep<a href=\"$cgi;action=imsend;caller=1;imsg=$messageid;reply=1;to=$musername;ry=1\">$img[im_reply]</a>$menusep";
			echo '
							<a href="javascript:DoConfirm(\'' . addslashes($txt[154]) . '?\',\'' . $cgi . ';action=imremove;caller=1;id=' . $messageid . ';sesc=' . $sc . '\');">' . $img['im_remove'] . '</a>
						</font>
					</td></tr></table>
				</td>
			</tr>';
		}
		echo '
		</table>';
	}
	footer();
	obExit();
}

function IMOutbox ()
{
	global $username, $txt, $img, $yytitle, $imagesdir, $cgi, $action, $mbname, $censored, $scripturl;
	global $menusep, $color, $ID_MEMBER, $yyUDLoaded, $userprofile, $membergroups, $memberstar, $memberinfo, $icqad;
	global $yimon, $currentboard, $profilebutton, $enable_ubbc, $settings, $allow_hide_email, $db_prefix, $sc;
	global $modSettings, $sender, $realNames;

	if ($username == 'Guest')
		fatal_error($txt[147]);
	$imbox = $txt[320];
	$txt[412] = str_replace('IMBOX', $imbox, $txt[412]);
	$img['im_delete'] = str_replace('IMBOX', $imbox, $img['im_delete']);

	// Fix moderator showing in info
	$sender = 'im';

	$yytitle = $txt[143];
	template_header();

	// Build the link tree
	$displayLinkTree = ($modSettings['enableInlineLinks'] ? "<font size=\"1\" class=\"nav\"><b><a href=\"$scripturl\" class=\"nav\">$mbname</a> </b>&nbsp;|&nbsp;<b> " : "<font size=\"2\" class=\"nav\"><b><img src=\"$imagesdir/open.gif\" border=\"0\" alt=\"\" />&nbsp;&nbsp;<a href=\"$scripturl\" class=\"nav\">$mbname</a><br />");
	$displayLinkTree .= ($modSettings['enableInlineLinks'] ? "<a href=\"$cgi;action=im\" class=\"nav\">$txt[144]</a> </b>&nbsp;|&nbsp;<b> " : "<img src=\"$imagesdir/tline.gif\" border=\"0\" alt=\"\" /><img src=\"$imagesdir/open.gif\" border=\"0\" alt=\"\" />&nbsp;&nbsp;<a href=\"$cgi;action=im\" class=\"nav\">$txt[144]</a><br />");
	$displayLinkTree .= ($modSettings['enableInlineLinks'] ? "$txt[320]</b></font>" : "<img src=\"$imagesdir/tline2.gif\" border=\"0\" alt=\"\" /><img src=\"$imagesdir/open.gif\" border=\"0\" alt=\"\" />&nbsp;&nbsp;<a href=\"$cgi;action=imoutbox\" class=\"nav\">$txt[320]</a></b></font>");
	echo '
		<script language="JavaScript1.2" type="text/javascript"><!--
			function DoConfirm(message, url) {
				if (confirm(message)) location.href = url;
			}
			function invertAll(field, headerfield)
			{
				for (i = 0; i < field.length; i++) {
					if (headerfield.checked == false )
						field[i].checked = true;
					else
						field[i].checked = false;
				}
				headerfield.checked = !(headerfield.checked);
			}
		//--></script>
		<table border="0" width="100%" cellspacing="0">
			<tr>
				<td valign="bottom">' . $displayLinkTree . '</td>
			</tr>
		</table>
		<form action="' . $cgi . ';action=imremovemore;caller=2" method="post" onsubmit="if (!confirm(\'' . $txt['yse249'] . '\')) return false;" style="margin-top: 0px;">
			<table cellpadding="0" cellspacing="0" border="0" width="100%" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" align="center"><tr><td>
				<table border="0" width="100%" cellspacing="1" bgcolor="' . $color['bordercolor'] . '" class="bordercolor">
					<tr>
						<td align="right" valign="bottom" class="catbg" bgcolor="' . $color['catbg'] . '" colspan="5">
							<font size="-1">';

	 // Load membergroups 
		$request = mysql_query("SELECT membergroup FROM {$db_prefix}membergroups WHERE 1 ORDER BY ID_GROUP") or database_error(__FILE__, __LINE__);
		$membergroups = array();
		while ($row = mysql_fetch_row($request))
			$membergroups[] = $row[0];

	// Read all messages
	$request = mysql_query("SELECT ID_IM, toName, subject, body, msgtime FROM {$db_prefix}instant_messages WHERE ID_MEMBER_FROM=$ID_MEMBER AND deletedBy != 0 ORDER BY ID_IM") or database_error(__FILE__, __LINE__);

	if (mysql_num_rows($request) > 0)
		echo "    <a href=\"$cgi;action=imremoveall;caller=2\">$img[im_delete]</a>$menusep";
	echo '
								<a href="' . $cgi . ';action=im">' . $img['im_inbox'] . '</a>' . $menusep . '<a href="' . $cgi . ';action=imsend">' . $img['im_new'] . '</a>' . $menusep . '<a href="' . $cgi . ';action=im">' . $img['im_reload'] . '</a>' . $menusep . '<a href="' . $cgi . ';action=imprefs">' . $img['im_config'] . '</a>
							</font>
						</td>
					</tr><tr>
						<td class="titlebg" bgcolor="' . $color['titlebg'] . '" width="300">
							<font size="2" class="text1" color="' . $color['titletext'] . '">&nbsp;<b>' . $txt[317] . '</b></font>
						</td>
						<td class="titlebg" bgcolor="' . $color['titlebg'] . '">
							<font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $txt[324] . '</b></font>
						</td>
						<td class="titlebg" bgcolor="' . $color['titlebg'] . '">
							<font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $txt[319] . '</b></font>
						</td>
						<td class="titlebg" bgcolor="' . $color['titlebg'] . '">
							<font size="2" class="text1" color="' . $color['titletext'] . '">' . $txt['yse138'] . '</font>
						</td>
						<td class="titlebg" bgcolor="' . $color['titlebg'] . '" align="center">
							<input class="titelbg" type="checkbox" style="background-color:' . $color['titlebg'] . '" onclick="invertAll(this.form, this)" />
						</td>
					</tr>';

	// Display Message if there are no Messages in Users Outbox
	if ( mysql_num_rows($request)  == 0 )
		echo '
					<tr>
						<td class="windowbg" colspan="5" bgcolor="' . $color['windowbg'] . '"><font size="2">' . $txt[151] . '</font></td>
					</tr>';

	$bgcolors = array($color['windowbg'], $color['windowbg2']);
	$bgstyles = array('windowbg', 'windowbg2');
	$bgcolornum = sizeof($bgcolors);
	$bgstylenum = sizeof($bgstyles);

	$counter = 0;
	$ims = array();
	while ($row = mysql_fetch_array($request))
	{
		$ims[] = $row['ID_IM'];
		$counter++;
		$windowbg = $bgcolors[($counter % $bgcolornum)];
		$windowcss = $bgstyles[($counter % $bgstylenum)];
		$musername = $row['toName'];
		$msub = $row['subject'];
		$mdate = $row['msgtime'];
		$immessage = $row['body'];
		$messageid = $row['ID_IM'];
		if ($msub == '')
			$msub = $txt[24];

		CensorTxt($msub);
		$mydate = timeformat($mdate);
		echo '
					<tr>
						<td class="' . $windowcss . '" bgcolor="' . $windowbg . '" width="300"><font size="2">' . $mydate . '</font></td>
						<td class="' . $windowcss . '" bgcolor="' . $windowbg . '"><font size="2">' . $musername . '</font></td>
						<td class="' . $windowcss . '" bgcolor="' . $windowbg . '"><font size="2"><a href="#' . $messageid . '">' . $msub . '</a></font></td>
						<td class="' . $windowcss . '" bgcolor="' . $windowbg . '">
							<font size="2">
								<a href="javascript:DoConfirm(\'' . addslashes($txt[154]) . '?\',\'' . $cgi . ';action=imremove;caller=2;id=' . $messageid . ';sesc=' . $sc . '\');">' . $img['im_remove'] . '</a>
							</font>
						</td>
						<td class="' . $windowcss . '" bgcolor="' . $windowbg . '" align="center">
							<input class="' . $windowcss . '" type="checkbox" name="delete_' . $messageid . '" />
						</td>
					</tr>';
	}
	echo '
					<tr>
						<td bgcolor="' . $windowbg . '" class="windowbg2" style="padding : 2px;" align="right" colspan="5">
							<input type="submit" value="' . $txt['yse138'] . '" />
						</td>
					</tr>
				</table>
			</td></tr></table>
			<input type="hidden" name="sc" value="' . $sc . '" />
		</form><br />';

	if (mysql_num_rows($request) > 0)
	{
		echo '
		<table border="0" width="100%" cellspacing="1" cellpadding="4" bgcolor="' . $color['bordercolor'] . '" class="bordercolor">
			<tr>
				<td class="titlebg" bgcolor="' . $color['titlebg'] . '"><font size="2" class="text1" color="' . $color['titletext'] . '">&nbsp;<b>' . $txt[535] . '</b></font></td>
				<td class="titlebg" bgcolor="' . $color['titlebg'] . '"><font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $txt[118] . '</b></font></td>
			</tr>';

		$request = mysql_query("
			SELECT im.toName, im.subject, im.msgtime, im.body, im.ID_IM, IFNULL(mem.ID_MEMBER, 0) AS ID_MEMBER_TO, IFNULL(mem.realName,im.toName) AS toDisplayName, IFNULL(lo.logTime, 0) AS isOnline
			FROM {$db_prefix}instant_messages AS im
				LEFT JOIN {$db_prefix}members AS mem ON (mem.ID_MEMBER=im.ID_MEMBER_TO)
				LEFT JOIN {$db_prefix}log_online AS lo ON (lo.identity=mem.ID_MEMBER)
			WHERE im.ID_IM IN (" . implode(',', $ims) . ")
			ORDER BY im.ID_IM") or database_error(__FILE__, __LINE__);
		$counter = 0;
		while ($row = mysql_fetch_array($request))
		{
			$counter++;
			$windowbg = $bgcolors[($counter % $bgcolornum)];
			$windowcss = $bgstyles[($counter % $bgstylenum)];
			$musername = $row['toName'];
			$msub = $row['subject'];
			$mdate = $row['msgtime'];
			$immessage = $row['body'];
			$messageid = $row['ID_IM'];

			if ($msub == '')
				$msub = $txt[24];
			$mydate = timeformat($mdate);
			
			// If user is not in memory, s/he must be loaded.
			$online = '';
			$title = '';
			if ($row['ID_MEMBER_TO'] > 0 && ! isset($yyUDLoaded[$musername]))
			{
				$realNames[$musername] = $row['toDisplayName'];
				LoadUserDisplay($musername);
			}
			if ( $yyUDLoaded[$musername] )
			{
				$star = $memberstar[$musername];
				$memberinf = $memberinfo[$musername];
				$icq = $icqad[$musername];
				$yim = $yimon[$musername];
				$euser = urlencode($musername);
				$usernamelink = "<a href=\"$scripturl?board=$currentboard;action=viewprofile;user=$euser\"><font size=\"2\"><b>{$userprofile[$musername]['realName']}</b></font></a>";
				$profbutton = ($profilebutton != '' && $musername != 'Guest' ? "$menusep<a href=\"$scripturl?action=viewprofile;user=$euser\">$img[viewprofile]</a>" : '');
				$postinfo = "$txt[26]: {$userprofile[$musername]['posts']}<br />";
				$memail = $userprofile[$musername]['emailAddress'];
				if ($modSettings['titlesEnable'] != '0' && $userprofile[$musername]['usertitle'] != '')
					$title = "{$userprofile[$musername]['usertitle']}<br />";
				if ($modSettings['onlineEnable'] != '0')
				{
					if ($row['isOnline'] > 0)
						$online = '<a href="' . $cgi . ';action=imsend;to=' . $euser . '">' . $txt['online2'] . '<br /><br />' . "\n";
					else 
						$online = '<a href="' . $cgi . ';action=imsend;to=' . $euser . '">' . $txt['online3'] . '<br /><br />' . "\n";
				}
				else 
					$online = '';
			}

			CensorTxt($immessage);
			CensorTxt($msub);

			$message = $immessage; // put the message back in the proper variable for doing ubbc
			if ($enable_ubbc)
				$message = DoUBBC($message);
			$message = str_replace('<br>', '<br />', $message);

			echo '
			<tr>
				<td class="' . $windowcss . '" bgcolor="' . $windowbg . '" width="160" valign="top" rowspan="2">
					' . $usernamelink . '<br />
					<font size="1">
						' . $title . '
						' . $memberinf . '<br />
						' . $star . '<br /><br />
						' . $online . '
						' . $postinfo . '
						' . $userprofile[$musername]['gender'] . '
						' . $userprofile[$musername]['avatar'] . '
						' . $userprofile[$musername]['personalText'] . '
						' . $userprofile[$musername]['ICQ'] . '
						' . $icq . ' &nbsp; ' . $yim . ' &nbsp; ' . $userprofile[$musername]['AIM'] . '
					</font>
				</td>
				<td class="' . $windowcss . '" bgcolor="' . $windowbg . '" valign="top" height="100%">
					<table border="0" cellspacing="0" cellpadding="3" width="100%" align="center" bgcolor="' . $color['bordercolor'] . '" class="bordercolor">
						<tr>
							<td class="' . $windowcss . '" bgcolor="' . $windowbg . '">
								<font size="1">
									<a name="' . $messageid . '" />&nbsp;<b>' . $msub . '</b>
								</font>
							</td>
							<td class="' . $windowcss . '" bgcolor="' . $windowbg . '" align="right">
								<font size="1">
									<b>' . $txt[30] . ':</b> ' . $mydate . '
								</font>
							</td>
						</tr><tr>
							<td colspan="2" class="' . $windowcss . '" bgcolor="' . $windowbg . '" height="10">
								<hr width="100%" size="1" style="color: ' . $color['windowbg3'] . '" />
							</td>
						</tr><tr>
							<td colspan="2" class="' . $windowcss . '" bgcolor="' . $windowbg . '" height="100%" valign="top">
								' . $message . '
							</td>
						</tr>
					</table>
				</td>
			</tr><tr>
				<td class="' . $windowcss . '" bgcolor="' . $windowbg . '" valign="bottom">
					<table width="100%"><tr>
						<td class="' . $windowcss . '" bgcolor="' . $windowbg . '" height="10">
							<font size="2">';

			if ($userprofile[$musername]['hideEmail'] != "1" || $settings[7] == "Administrator" || $allow_hide_email != 1)
				echo "{$userprofile[$musername]['websiteUrl_IM']}$menusep<a href=\"mailto:$memail\">$img[email]</a>$profbutton\n";
			else
				echo "{$userprofile[$musername]['websiteUrl_IM']}$menusep$profbutton\n";
			echo '
							</font>
						</td>
						<td class="' . $windowcss . '" bgcolor="' . $windowbg . '" align="right" height="10">
							<font size="2">
								<a href="' . $cgi . ';action=imsend;caller=2;imsg=' . $messageid . ';quote=1;to=' . $musername . '">' . $img['replyquote'] . '</a>' . $menusep . '<a href="' . $cgi . ';action=imsend;caller=2;imsg=' . $messageid . ';reply=1;to=' . $musername . '">' . $img['im_reply'] . '</a>' . $menusep . '<a href="javascript:DoConfirm(\'' . addslashes($txt[154]) . '?\',\'' . $cgi . ';action=imremove;caller=2;id=' . $messageid . ';sesc=' . $sc . '\');">' . $img['im_remove'] . '</a>
							</font>
						</td>
					</tr></table>
				</td>
			</tr>';
		}
		echo '
		</table>';
	}
	footer();
	obExit();
}


function IMPost()
{
	global $username, $txt, $yytitle, $cgi, $img, $imagesdir, $color, $ubbcjspath, $mbname, $menusep, $imsg;
	global $showyabbcbutt, $enable_ubbc, $form_subject, $scripturl, $to, $form_message, $reply, $quote;
	global $sourcedir, $db_prefix, $modSettings, $ID_MEMBER, $ry, $sc;

	if ($username == 'Guest')
		fatal_error($txt[147]);
	$yytitle = $txt[148];
	template_header();
	if (isset($imsg))
	{
		$request = mysql_query ("SELECT * FROM {$db_prefix}instant_messages WHERE (ID_IM='$imsg' AND (ID_MEMBER_TO='$ID_MEMBER' || ID_MEMBER_FROM='$ID_MEMBER'))") or database_error(__FILE__, __LINE__);
		if (mysql_num_rows($request) == 0)
			fatal_error('Hacker?');

		$row = mysql_fetch_array($request);
		$mfrom = $row['fromName'];
		$msubject = $row['subject'];
		$mdate = $row['msgtime'];
		$mmessage = $row['body'];
		$messageid = $row['ID_IM'];
		$mydate = timeformat($mdate);
		$srmessage = doUBBC($mmessage);

		$form_subject = $msubject;
		if (!stristr(substr($form_subject,0,3), 're:') && ($reply == '1' || $quote == '1'))
			$form_subject = "Re:$form_subject";

		if ($quote == '1')
		{
			$mmessage =  preg_replace("|<br( /)?[>]|","\n", $mmessage);
			if ($modSettings['removeNestedQuotes'] == '1')
			{
				$mmessage = preg_replace("-\n*\[quote([^\\]]*)\]((.|\n)*?)\[/quote\]([\n]*)-", '', $mmessage);
				$mmessage = preg_replace("/\n*\[\/quote\]\n*/", '', $mmessage);
			}
			$form_message = "[quote] $mmessage [/quote]";
		}
	}

	$form_subject = (isset($form_subject) ? $form_subject : $txt[24]);
	# Build the link tree
	$displayLinkTree = ($modSettings['enableInlineLinks'] ? "<font size=\"1\" class=\"nav\"><b><a href=\"$scripturl\" class=\"nav\">$mbname</a> </b>&nbsp;|&nbsp;<b> " : "<font size=\"2\" class=\"nav\"><b><img src=\"$imagesdir/open.gif\" border=\"0\" alt=\"\" />&nbsp;&nbsp;<a href=\"$scripturl\" class=\"nav\">$mbname</a><br />");
	$displayLinkTree .= ($modSettings['enableInlineLinks'] ? "<a href=\"$cgi;action=im\" class=\"nav\">$txt[144]</a> </b>&nbsp;|&nbsp;<b> " : "<img src=\"$imagesdir/tline.gif\" border=\"0\" alt=\"\" /><img src=\"$imagesdir/open.gif\" border=\"0\" alt=\"\" />&nbsp;&nbsp;<a href=\"$cgi;action=im\" class=\"nav\">$txt[144]</a><br />");
	$displayLinkTree .= ($modSettings['enableInlineLinks'] ? "$txt[321]</b></font>" : "<img src=\"$imagesdir/tline2.gif\" border=\"0\" alt=\"\" /><img src=\"$imagesdir/open.gif\" border=\"0\" alt=\"\" />&nbsp;&nbsp;<a href=\"$cgi;action=imsend\" class=\"nav\">$txt[321]</a></b></font>");

	echo '
		<script language="JavaScript1.2" src="' . $ubbcjspath . '" type="text/javascript"></script>
		<table border="0" width="75%" cellpadding="3" align="center" cellspacing="0">
			<tr>
				<td valign="bottom">' . $displayLinkTree . '</td>
			</tr>
		</table>
		<table cellpadding="0" cellspacing="0" border="0" width="75%" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" align="center"><tr><td>
			<table border="0" width="100%" cellspacing="1" bgcolor="' . $color['bordercolor'] . '" class="bordercolor">
				<tr>
					<td align="right" valign="bottom" class="catbg" bgcolor="' . $color['catbg'] . '" colspan="4">
						<font size="-1">
							<a href="' . $cgi . ';action=im">' . $img['im_inbox'] . '</a>' . $menusep . '<a href="' . $cgi . ';action=imoutbox">' . $img['im_outbox'] . '</a>' . $menusep . '<a href="' . $cgi . ';action=im">' . $img['im_reload'] . '</a>' . $menusep . '<a href="' . $cgi . ';action=imprefs">' . $img['im_config'] . '</a>
						</font>
					</td>
				</tr>
			</table>
		</td></tr></table>
		<table border="0" width="75%" align="center" cellpadding="3" cellspacing="1" bgcolor="' . $color['bordercolor'] . '" class="bordercolor">
			<tr>
				<td class="titlebg" bgcolor="' . $color['titlebg'] . '"><font size="2" class="text1" color="' . $color['titletext'] . '">' . $img['im_new_small'] . '&nbsp;<b>' . $txt[321] . '</b></font></td>
			</tr><tr>
				<td class="windowbg" bgcolor="' . $color['windowbg'] . '">
					<form action="' . $cgi . ';action=imsend2" method="post" name="postmodify" onsubmit="if (document.postmodify.subject.value == \'\' || document.postmodify.message.value == \'\' || document.postmodify.to.value == \'\') { alert(\'' . $txt['jsvalidate2'] . '\'); return false; } else { submitonce(this); }">
						<table border="0" cellpadding="3" width="100%">
							<tr>
								<td align="right"><font size="2"><b>' . $txt[150] . ':</b></font></td>
								<td><font size="2">
									<input type="text" name="to" value="' . $to . '" size="20" maxlength="50" />
									<font size="1">' . $txt[748] . '</font></font>
								</td>
							</tr><tr>
								<td align="right"><font size="2"><b>' . $txt[70] . ':</b></font></td>
								<td><font size="2"><input type="text" name="subject" value="' . $form_subject . '" size="40" maxlength="50" /></font></td>
							</tr>';

	include_once("$sourcedir/Post.php");
	printPostBox($form_message);
	echo '
							<tr>
								<td align="center" colspan="2">
									<input type="hidden" name="waction" value="imsend" />
									<input type="submit" value="' . $txt[148] . '" onclick="WhichClicked(\'imsend\');" accesskey="s" />
									<input type="submit" name="preview" value="' . $txt[507] . '" onclick="WhichClicked(\'previewim\');" />
									<input type="reset" value="' . $txt[329] . '" />
								</td>
							</tr>
						</table>
						<input type="hidden" name="sc" value="' . $sc . '" />
					</form>
				</td>
			</tr>
		</table>';

	if ($ry == 1)
		echo '
		<br /><br />
		<table class="bordercolor" width="100%" border="0" cellspacing="1" cellpadding="4">
			<tr>
				<td colspan="2" class="windowbg" bgcolor="' . $color['windowbg'] . '"><b>' . $txt[319] . ': ' . $msubject . '</b></td>
			</tr><tr>
				<td class="windowbg2" bgcolor="' . $color['windowbg2'] . '">' . $txt[318] . ': ' . $mfrom . '</td>
				<td align="right" class="windowbg2" bgcolor="' . $color['windowbg'] . '">' . $txt[30] . ': ' . $mydate . '</td>
			</tr><tr>
				<td class="windowbg" bgcolor="' . $color['windowbg'] . '" colspan="2">' . $srmessage . '</td>
			</tr>
		</table>';

	footer();
	obExit();
}

function IMPost2()
{
	global $subject, $username, $realname, $txt, $waction, $subject, $settings, $MaxMessLen, $message, $to, $yySetLocation, $cgi;
	global $sourcedir, $db_prefix, $language, $chklngfile, $chklngfile2, $modSettings;

	checkSession();
	$nouser = array();
	if ($username == 'Guest')
		fatal_error($txt[147]);
	$subject = trim ($subject);
	if (strlen($message) > $MaxMessLen)
		fatal_error($txt[499]);

	if ($subject == '')
		fatal_error("$txt[77]");
	if ($message == '')
		fatal_error("$txt[78]");
	if ($to == '')
		fatal_error("'' $txt[747]");

	$mmessage = $message;
	$msubject = $subject;

	if ($waction == 'previewim')
	{
		include_once ("$sourcedir/Post.php");
		Preview();
	}
	else
	{
		$message = htmlspecialchars($message, ENT_QUOTES);
		$subject = htmlspecialchars($subject);
	}

	$message = preparsecode($message, $realname, $username);
	$message = str_replace(array("\n", "\r"), array('<br />', ''), $message);

	$curlanguage = $chklngfile == Null ? $language : $chklngfile2;

	$nouser = array();
	$multiple = array_unique(explode(',', $to));
	foreach ($multiple as $db)
	{
		$db = trim($db);
		$ignored = 0;
		$db = preg_replace("/[^0-9A-Za-z#%+\s,-\.:=?@^_]/", '', $db);

		# Check Ignore-List
		$request = mysql_query("SELECT im_ignore_list,ID_MEMBER,im_email_notify,emailAddress,lngfile FROM {$db_prefix}members WHERE memberName='$db' LIMIT 1") or database_error(__FILE__, __LINE__);
		$row = mysql_fetch_row($request);
		$ignore = explode(',', $row[0]);
		$toID = $row[1];
		$emailNotify = $row[2];
		$notifyAddress = $row[3];
		$userlng = $row[4];

		# If User is on Recipient's Ignore-List, show Error Message
		foreach ($ignore as $igname)
		{
			#adds ignored user's name to array which error list will be built from later
			if ($igname == $username || $igname == "*")
			{
				$nouser[] = $db;
				$ignored = 1;
			}
		}

		if (mysql_num_rows($request) == 0)
		{
			#adds invalid user's name to array which error list will be built from later
			$nouser[] = $db;
			$ignored = 1;
		}

		if (get_magic_quotes_gpc() == 0)
		{
			$subject = mysql_escape_string($subject);
			$message = mysql_escape_string($message);
		}

		if (!$ignored)
		{
			$result = mysql_query("SELECT ID_MEMBER FROM {$db_prefix}members WHERE memberName='$username'") or database_error(__FILE__, __LINE__);
			$row = mysql_fetch_row($result);
			$fromID = $row[0];
			$result = mysql_query("
				INSERT INTO {$db_prefix}instant_messages (ID_MEMBER_FROM,ID_MEMBER_TO,fromName,toName,msgtime,subject,body)
				VALUES ($fromID,$toID,'$username','$db'," . time() . ",'$subject','$message')") or database_error(__FILE__, __LINE__);

			# Send notification
			if ($emailNotify == 1)
			{
				$mydate = timeformat(time());
				if ($notifyAddress != '')
				{
					if ($modSettings['userLanguage'] == 1)
					{
						$desiredlanguage = (($userlng == Null || $userlng == '') ? $language : $userlng);
						if ($desiredlanguage != $curlanguage)
						{
							include($desiredlanguage);
							$curlanguage = $desiredlanguage;
						}
					}
					$fromname = $settings[1];
					$txt[561] = str_replace ('SUBJECT', $msubject, $txt[561]);
					$txt[561] = str_replace ('SENDER', $fromname, $txt[561]);
					$txt[562] = str_replace ('DATE', strip_tags($mydate), $txt[562]);
					$txt[562] = str_replace ('MESSAGE', strip_tags($mmessage), $txt[562]);
					$txt[562] = str_replace ('SENDER', $fromname, $txt[562]);
					sendmail($notifyAddress, $txt[561], $txt[562]);
				}
			}
		}
	}

	#if there were invalid usernames in the recipient list, these names are listed after all valid users have been IMed
	if (sizeof($nouser) > 0)
	{
		$badusers = join(', ', $nouser);
		fatal_error("$badusers $txt[747]");
	}

	$yySetLocation = "$cgi;action=im";
	redirectexit();
}

function IMRemoveMore()
{
	global $username, $txt, $yySetLocation, $cgi, $caller, $db_prefix, $ID_MEMBER, $HTTP_POST_VARS;

	checkSession();
	if ($username == 'Guest')
		fatal_error($txt[147]);

	$field = ($caller == 1 ? '1' : '0');

	foreach( $HTTP_POST_VARS as $postVar => $postVarValue )
	{
		if (strcmp(substr($postVar, 0, 7), 'delete_') == 0)
		{
			$id = substr($postVar, 7);

			$check = mysql_query("SELECT deletedBy FROM {$db_prefix}instant_messages WHERE (ID_IM=$id AND ID_MEMBER_" . ($caller == 1 ? 'TO' : 'FROM') . "='$ID_MEMBER')") or database_error(__FILE__, __LINE__);
			if (mysql_num_rows($check) < 1)
				fatal_error ('Hacker?');

			$request = mysql_query ( "SELECT deletedBy FROM {$db_prefix}instant_messages WHERE (ID_IM=$id AND deletedBy != -1)" ) or database_error(__FILE__, __LINE__);
			if (mysql_num_rows($request) > 0)
				$request = mysql_query("DELETE FROM {$db_prefix}instant_messages WHERE ID_IM=$id") or database_error(__FILE__, __LINE__);
			else
				$request = mysql_query ("UPDATE {$db_prefix}instant_messages SET deletedBy=$field WHERE ID_IM=$id") or database_error(__FILE__, __LINE__);
		}
	}

	$redirect = ($caller == 1 ? 'im' : 'imoutbox');
	$yySetLocation = "$cgi;action=$redirect";
	redirectexit();
}

function IMRemove()
{
	global $username, $txt, $yySetLocation, $cgi, $caller, $id, $db_prefix, $ID_MEMBER;
	
	checkSession('get');

	if ($username == 'Guest')
		fatal_error($txt[147]);
	
	if ($caller == 1)
		$field = "1";
	else
		$field = "0";

	$check = mysql_query("SELECT deletedBy FROM {$db_prefix}instant_messages WHERE (ID_IM=$id AND ID_MEMBER_" . ($caller == 1 ? 'TO' : 'FROM') . "='$ID_MEMBER')") or database_error(__FILE__, __LINE__);

	if (mysql_num_rows($check) < 1)
		fatal_error ("Hacker?");

	$request = mysql_query ("SELECT deletedBy FROM {$db_prefix}instant_messages WHERE (ID_IM=$id AND deletedBy != -1)") or database_error(__FILE__, __LINE__);
	if (mysql_num_rows($request) > 0)
		$request = mysql_query("DELETE FROM {$db_prefix}instant_messages WHERE ID_IM=$id") or database_error(__FILE__, __LINE__);
	else
		$request = mysql_query ("UPDATE {$db_prefix}instant_messages SET deletedBy=$field WHERE ID_IM=$id") or database_error(__FILE__, __LINE__);

	$redirect = ($caller == 1) ? 'im' : 'imoutbox';
	$yySetLocation = "$cgi;action=$redirect";
	redirectexit();
}

function IMPreferences ()
{
	global $username, $txt, $ID_MEMBER, $yytitle, $cgi, $img, $imagesdir, $scripturl, $color, $mbname;
	global $db_prefix, $settings, $menusep, $color, $modSettings, $sc;

	if ($username == 'Guest')
		fatal_error($txt[147]);

	$request = mysql_query("SELECT im_ignore_list,im_email_notify FROM {$db_prefix}members WHERE ID_MEMBER=$ID_MEMBER") or database_error(__FILE__, __LINE__);
	$imconfig = mysql_fetch_row($request);

	$sel0 = ($imconfig[1] ? '' : ' selected="selected"');
	$sel1 = ($imconfig[1] ? ' selected="selected"' : '');

	$ignores = str_replace(',', "\n", $imconfig[0]);
	$yytitle = "$txt[323]: $txt[144]";

	// Build the link tree
	$displayLinkTree = ($modSettings['enableInlineLinks'] ? "<font size=\"1\" class=\"nav\"><b><a href=\"$scripturl\" class=\"nav\">$mbname</a> </b>&nbsp;|&nbsp;<b> " : "<font size=\"2\" class=\"nav\"><b><img src=\"$imagesdir/open.gif\" border=\"0\" alt=\"\" />&nbsp;&nbsp;<a href=\"$scripturl\" class=\"nav\">$mbname</a><br />");
	$displayLinkTree .= ($modSettings['enableInlineLinks'] ? "<a href=\"$cgi;action=im\" class=\"nav\">$txt[144]</a> </b>&nbsp;|&nbsp;<b> " : "<img src=\"$imagesdir/tline.gif\" border=\"0\" alt=\"\" /><img src=\"$imagesdir/open.gif\" border=\"0\" alt=\"\" />&nbsp;&nbsp;<a href=\"$cgi;action=im\" class=\"nav\">$txt[144]</a><br />");
	$displayLinkTree .= ($modSettings['enableInlineLinks'] ? "$txt[323]</b></font>" : "<img src=\"$imagesdir/tline2.gif\" border=\"0\" alt=\"\" /><img src=\"$imagesdir/open.gif\" border=\"0\" alt=\"\" />&nbsp;&nbsp;<a href=\"$cgi;action=imprefs\" class=\"nav\">$txt[323]</a></b></font>");

	template_header();

	echo '
		<table border="0" width="75%" align="center" cellspacing="0">
			<tr>
				<td valign="bottom">' . $displayLinkTree . '</td>
			</tr>
		</table>
		<table cellpadding="0" cellspacing="0" border="0" width="75%" align="center" bgcolor="' . $color['bordercolor'] . '" class="bordercolor"><tr><td>
			<table border="0" width="100%" cellspacing="1" bgcolor="' . $color['bordercolor'] . '" class="bordercolor">
				<tr>
					<td align="right" valign="bottom" class="catbg" bgcolor="' . $color['catbg'] . '" colspan="4"><font size="-1">
						<a href="' . $cgi . ';action=im">' . $img['im_inbox'] . '</a>' . $menusep . '<a href="' . $cgi . ';action=imoutbox">' . $img['im_outbox'] . '</a>' . $menusep . '<a href="' . $cgi . ';action=imsend">' . $img['im_new'] . '</a>' . $menusep . '<a href="' . $cgi . ';action=im">' . $img['im_reload'] . '</a>
					</font>
					</td>
				</tr>
			</table>
		</td></tr></table>
		<table border="0"  width="75%" align="center" cellspacing="1" bgcolor="' . $color['bordercolor'] . '" class="bordercolor">
			<tr>
				<td class="titlebg" bgcolor="' . $color['titlebg'] . '">
					<font size="2" class="text1" color="' . $color['titletext'] . '">
						' . $img['im_config_small'] . '&nbsp;<b>' . $txt[323] . '</b>
					</font>
				</td>
			</tr>
			<tr>
				<td class="windowbg" bgcolor="' . $color['windowbg'] . '">
					<form action="' . $cgi . ';action=imprefs2" method="post">
						<table border="0" width="100%">
							<tr>
								<td valign="top" align="right">
									<font size="2"><b>' . $txt[325] . ':</b></font><br /><font size="1">' . $txt[326] . '</font>
								</td>
								<td>
									<font size="2"><textarea name="ignore" rows="10" cols="50">' . $ignores . '</textarea></font>
								</td>
							</tr><tr>
								<td valign="top" align="right">
									<font size="2"><b>' . $txt[327] . ':</b></font>
								</td>
								<td>
									<font size="2">
										<select name="notify">
											<option value="0"' . $sel0 . '>' . $txt[164] . '</option>
											<option value="1"' . $sel1 . '>' . $txt[163] . '</option>
										</select>
									</font>
								</td>
							</tr>
							<tr>
								<td>
									&nbsp;
								</td>
								<td>
									<input type="submit" value="' . $txt[328] . '" />
									<input type="reset" value="' . $txt[329] . '" />
								</td>
							</tr>
						</table>
						<input type="hidden" name="sc" value="' . $sc .'" />
					</form>
				</td>
			</tr>
		</table>';

	footer();
	obExit();
}

function IMPreferences2 ()
{
	global $username, $ID_MEMBER, $yySetLocation, $ignore, $notify, $cgi, $db_prefix;
	
	checkSession();
	if ($username == 'Guest')
		fatal_error($txt[147]);
	
	$ignorelist = $ignore;
	$ignorelist = str_replace("\n", ',', trim($ignorelist));
	
  if(!get_magic_quotes_gpc())
      $ignorelist = addslashes($ignorelist);

	$request = mysql_query("UPDATE {$db_prefix}members SET im_ignore_list='$ignorelist',im_email_notify=$notify WHERE ID_MEMBER=$ID_MEMBER") or database_error(__FILE__, __LINE__);
	$yySetLocation = "$cgi;action=imprefs";

	redirectexit();
}

function KillAll ()
{
	global $username, $caller, $id, $ID_MEMBER, $cgi, $yySetLocation, $db_prefix;
	
checkSession('get');

	if ($username == 'Guest')
		fatal_error($txt[147]);

	if ($caller == 1)
	{
		$field2 = '0';
		$field = 'ID_MEMBER_TO';
		$field3 = '1';
		$redirect = 'im';
	}
	elseif ($caller == 2)
	{
		$redirect = 'imoutbox';
		$field2 = '1';
		$field = 'ID_MEMBER_FROM';
		$field3 = '0';
	}

	$request = mysql_query("DELETE FROM {$db_prefix}instant_messages WHERE ($field=$ID_MEMBER && deletedBy = $field2)") or database_error(__FILE__, __LINE__);
	$request = mysql_query ("UPDATE {$db_prefix}instant_messages SET deletedBy=$field3 WHERE $field=$ID_MEMBER") or database_error(__FILE__, __LINE__);

	$redirect = ($caller == 1 ? 'im' : 'imoutbox');

	$yySetLocation = "$cgi;action=$redirect";
	redirectexit();
}

function KillAllQuery ()
{
	global $username, $txt, $cgi, $yytitle, $img, $caller, $color, $yySetLocation, $db_prefix, $sc;

	$imbox = '';
	if ($username == 'Guest')
		fatal_error($txt[147]);
	if ($caller == 1)
	{
		$yytitle .= $txt[316];
		$imbox = $txt[316];
		$cgi2 = "$cgi;action=imremoveall2;caller=1;sesc=$sc";
		$cgi .= ";action=im";
	}
	elseif ($caller == 2)
	{
		$yytitle .= $txt[320];
		$imbox = $txt[320];
		$cgi2 = "$cgi;action=imremoveall2;caller=2;sesc=$sc";
		$cgi .= ";action=imoutbox";
	}
	$txt[412] = str_replace('IMBOX', $imbox, $txt[412]);
	$img['im_delete'] = str_replace('IMBOX', $imbox, $img['im_delete']);

	template_header();
	$yytitle = $txt[412];

	echo '
		<table border="0" width="80%" cellspacing="1" bgcolor="' . $color['bordercolor'] . '" class="bordercolor" align="center">
			<tr>
				<td class="titlebg" bgcolor="' . $color['titlebg'] . '"><font size="2" class="text1" color="' . $color['titletext'] . '"><b>' . $txt[412] . '</b></font></td>
			</tr>
			<tr>
				<td class="windowbg" bgcolor="' . $color['windowbg'] . '">
					<font size="2">
						' . $txt[413] . '<br />
						<b><a href="' . $cgi2 . '">' . $txt[163] . '</a> - <a href="' . $cgi . '">' . $txt[164] . '</a></b>
					</font>
				</td>
			</tr>
		</table>';
	footer();
	obExit();
}

?>
